# gfrcmd

## Name

gfrcmd -- Gfarm remote shell

## Synopsis

gfrcmd `host` `command`...

## DESCRIPTION

gfrcmd logs into a filesystem node `host` and executes `command`s on the filesystem node. It provides a similar functionality to rsh. The following is a list of differences, however.

A remote server is not executed by inetd, but is incorporated with gfsd(8).

The user is authenticated and authorized by the Gfarm security mechanism. Since this does not rely on privileged TCP ports for authentication like rsh, the maximum number of remote executions is not limited by the number of privileged ports.

Unlike rsh, gfrcmd utilizes a single TCP connection to a filesystem node. It requires less kernel resources than rsh when several processes are executed.

gfrcmd inherits the environment variable DISPLAY and the authentication information of the X Window System.

On the filesystem node, the current working directory is not the home directory that is often shared using NFS, but a spool directory of the Gfarm filesystem, which makes it possible to leave core files on each filesystem node when debugging.

It has functionality that invokes a debugger when a fatal signal occurs.

## OPTIONS

`-l` `username`

  Specifies a username on a remote host.

`-n`

  Redirects the standard input from the special device /dev/null.

`-r`

  Executes a remote command directly without using a login shell.

`-y`

  Inherits the environment variable, DISPLAY.

`-X`

  Inherits the authentication information of the X Window System. It is useful in a situation where the home directory is not shared.

`-v`

  Displays error message verbosely.

`-?`

  Displays a list of command options.

## ENVIRONMENT VARIABLES

`GFARM_DEBUG_MODE`

  Specifies the debugger command that is invoked when a remotely executed command aborts with a fatal signal. When gdb is specified, xterm and the GNU debugger gdb are executed. To utilize this functionality, it is necessary to invoke gfrcmd on the X Window System.

## BUGS

The -l option is not implemented yet.